<!doctype html>
<html lang="en">
<head>
  <title>Media Feeds</title>
  <meta charset="utf-8">
  <link rel="stylesheet" href="chrome://resources/css/text_defaults.css">
  <script src="chrome://resources/mojo/mojo/public/js/mojo_bindings_lite.js"></script>
  <script src="chrome://resources/js/promise_resolver.js"></script>
  <script src="chrome://resources/mojo/mojo/public/mojom/base/big_buffer.mojom-lite.js"></script>
  <script src="chrome://resources/mojo/mojo/public/mojom/base/string16.mojom-lite.js"></script>
  <script src="chrome://resources/mojo/mojo/public/mojom/base/unguessable_token.mojom-lite.js"></script>
  <script src="chrome://resources/mojo/mojo/public/mojom/base/time.mojom-lite.js"></script>
  <script src="chrome://resources/mojo/url/mojom/origin.mojom-lite.js"></script>
  <script src="chrome://resources/mojo/url/mojom/url.mojom-lite.js"></script>
  <script src="ui/gfx/geometry/mojom/geometry.mojom-lite.js"></script>
  <script src="services/media_session/public/mojom/media_session.mojom-lite.js"></script>
  <script src="chrome://resources/js/assert.js"></script>
  <script src="chrome://resources/js/util.js"></script>

  <script src="chrome/browser/media/feeds/media_feeds_store.mojom-lite.js">
  </script>

  <script src="chrome://resources/js/cr.js"></script>
  <script src="chrome://resources/js/cr/ui.js"></script>

  <script src="chrome://media-feeds/media-data-table.js"></script>
  <script src="chrome://media-feeds/media-feeds.js"></script>
  <style>
    body {
      font-family: 'Roboto', 'Noto', sans-serif;
      font-size: 14px;
    }

    button {
      margin-bottom: 20px;
    }

    table {
      border-collapse: collapse;
      margin-bottom: 20px;
    }

    table td,
    table th {
      border: 1px solid #777;
      padding-inline-end: 4px;
      padding-inline-start: 4px;
    }

    table th {
      background: rgb(224, 236, 255);
      cursor: pointer;
      padding-bottom: 4px;
      padding-inline-end: 4px;
      padding-top: 4px;
      white-space: nowrap;
    }

    .url-cell {
      background-color: rgba(230, 230, 230, 0.5);
    }

    .name-cell {
      background-color: rgba(230, 230, 230, 0.5);
    }

    table tr:hover {
      background: rgb(255, 255, 187);
    }

    th.sort-column {
      padding-inline-end: 16px;
    }

    th.sort-column::after {
      content: '▲';
      position: absolute;
    }

    th[sort-reverse].sort-column::after {
      content: '▼';
      position: absolute;
    }

    div#fetch-logs-content {
      color: red;
    }
  </style>
</head>
<body>
  <h1>Media Feeds</h1>
  <button id="copy-all-to-clipboard">Copy all to clipboard</button>
  <table>
    <thead>
      <tr id="config-table-header">
        <th>
          Setting Name
        </th>
        <th>
          Setting Value
        </th>
      </tr>
    </thead>
    <tbody id="config-table-body">
    </tbody>
  </table>
  <table id="feeds-table">
    <thead>
      <tr id="feed-table-header">
        <th sort-key="id" class="sort-column" sort-reverse>
          ID
        </th>
        <th sort-key="url">
          Url
        </th>
        <th sort-key="displayName">
          Display Name
        </th>
        <th sort-key="lastDiscoveryTime">
          Last Discovery Time
        </th>
        <th sort-key="lastFetchTime">
          Last Fetch Time
        </th>
        <th sort-key="userStatus">
          User Status
        </th>
        <th sort-key="userIdentifier">
          User ID
        </th>
        <th sort-key="lastFetchResult">
          Last Fetch Result
        </th>
        <th sort-key="fetchFailedCount">
          Fetch Failed Count
        </th>
        <th sort-key="lastFetchTimeNotCacheHit">
          Last Fetch Time (not cache hit)
        </th>
        <th sort-key="lastFetchItemCount">
          Last Fetch Item Count
        </th>
        <th sort-key="lastFetchPlayNextCount">
          Last Fetch Play Next Count
        </th>
        <th sort-key="lastFetchContentTypes">
          Last Fetch Content Types
        </th>
        <th sort-key="lastDisplayTime">
          Last Display Time
        </th>
        <th sort-key="resetReason">
          Reset Reason
        </th>
        <th data-key="cookieNameFilter">
          Cookie Name Filter
        </th>
        <th data-key="safeSearchResult">
          Safe Search Result
        </th>
        <th data-key="favicon">
          Favicon
        </th>
        <th data-key="logos">
          Logos
        </th>
        <th data-key="actions">
          Actions
        </th>
      </tr>
    </thead>
    <tbody id="feed-table-body">
    </tbody>
  </table>

  <div id="feed-content" style="display:none;">
    <hr>
    <h2>Feed Contents: <span id="current-feed"></span></h2>
    <table id="feed-items-table">
      <thead>
        <tr>
          <th sort-key="type" class="sort-column" sort-reverse>
            Type
          </th>
          <th sort-key="name">
            Name
          </th>
          <th sort-key="author">
            Author
          </th>
          <th sort-key="datePublished">
            Date Published
          </th>
          <th sort-key="isFamilyFriendly">
            Family Friendly
          </th>
          <th sort-key="actionStatus">
            Action Status
          </th>
          <th sort-key="action.url">
            Action URL
          </th>
          <th sort-key="action.startTime">
            Action Start Time (secs)
          </th>
          <th sort-key="interactionCounters">
            Interaction Counters
          </th>
          <th sort-key="contentRatings">
            Content Ratings
          </th>
          <th sort-key="genre">
            Genre
          </th>
          <th sort-key="live">
            Live Details
          </th>
          <th sort-key="tvEpisode">
            TV Episode
          </th>
          <th sort-key="playNextCandidate">
            Play Next Candidate
          </th>
          <th sort-key="identifiers">
            Identifiers
          </th>
          <th sort-key="shownCount">
            Shown Count
          </th>
          <th sort-key="clicked">
            Clicked
          </th>
          <th sort-key="images">
            Images
          </th>
          <th sort-key="safeSearchResult">
            Safe Search Result
          </th>
          <th sort-key="duration">
            Duration (secs)
          </th>
        </tr>
      </thead>
      <tbody>
      </tbody>
    </table>
    <div id="fetch-logs">
      <h3>Fetch logs:</h3>
      <div id="fetch-logs-content"></div>
    </div>
  </div>
</body>
</html>
